#pragma once

#include <tiba/core/json.hpp>

namespace tiba::input {

enum class Key {
	Invalid,
	Apostrophe,
	Comma,
	Minus,
	Period,
	Slash,
	Zero,
	One,
	Two,
	Three,
	Four,
	Five,
	Six,
	Seven,
	Eight,
	Nine,
	Semicolon,
	Equal,
	A,
	B,
	C,
	D,
	E,
	F,
	G,
	H,
	I,
	J,
	K,
	L,
	M,
	N,
	O,
	P,
	Q,
	R,
	S,
	T,
	U,
	V,
	W,
	X,
	Y,
	Z,
	LeftBracket,
	Backslash,
	RightBracket,
	Grave,
	Space,
	Escape,
	Enter,
	Tab,
	Backspace,
	Insert,
	Delete,
	Right,
	Left,
	Down,
	Up,
	PageUp,
	PageDown,
	Home,
	End,
	CapsLock,
	ScrollLock,
	NumLock,
	PrintScreen,
	Pause,
	F1,
	F2,
	F3,
	F4,
	F5,
	F6,
	F7,
	F8,
	F9,
	F10,
	F11,
	F12,
	LeftShift,
	LeftControl,
	LeftAlt,
	LeftSuper,
	RightShift,
	RightControl,
	RightAlt,
	RightSuper,
	Kb_Menu,
	Kp0,
	Kp1,
	Kp2,
	Kp3,
	Kp4,
	Kp5,
	Kp6,
	Kp7,
	Kp8,
	Kp9,
	KpDecimal,
	KpDivide,
	KpMultiply,
	KpSubtract,
	KpAdd,
	KpEnter,
	KpEqual,
	Back,
	Menu,
	VolumeUp,
	VolumeDown,
	Last,
};

NLOHMANN_JSON_SERIALIZE_ENUM(Key, {
																			{Key::Invalid, nullptr},
																			{Key::Apostrophe, "Apostrophe"},
																			{Key::Comma, "Comma"},
																			{Key::Minus, "Minus"},
																			{Key::Period, "Period"},
																			{Key::Slash, "Slash"},
																			{Key::Zero, "Zero"},
																			{Key::One, "One"},
																			{Key::Two, "Two"},
																			{Key::Three, "Three"},
																			{Key::Four, "Four"},
																			{Key::Five, "Five"},
																			{Key::Six, "Six"},
																			{Key::Seven, "Seven"},
																			{Key::Eight, "Eight"},
																			{Key::Nine, "Nine"},
																			{Key::Semicolon, "Semicolon"},
																			{Key::Equal, "Equal"},
																			{Key::A, "A"},
																			{Key::B, "B"},
																			{Key::C, "C"},
																			{Key::D, "D"},
																			{Key::E, "E"},
																			{Key::F, "F"},
																			{Key::G, "G"},
																			{Key::H, "H"},
																			{Key::I, "I"},
																			{Key::J, "J"},
																			{Key::K, "K"},
																			{Key::L, "L"},
																			{Key::M, "M"},
																			{Key::N, "N"},
																			{Key::O, "O"},
																			{Key::P, "P"},
																			{Key::Q, "Q"},
																			{Key::R, "R"},
																			{Key::S, "S"},
																			{Key::T, "T"},
																			{Key::U, "U"},
																			{Key::V, "V"},
																			{Key::W, "W"},
																			{Key::X, "X"},
																			{Key::Y, "Y"},
																			{Key::Z, "Z"},
																			{Key::LeftBracket, "LeftBracket"},
																			{Key::Backslash, "Backslash"},
																			{Key::RightBracket, "RightBracket"},
																			{Key::Grave, "Grave"},
																			{Key::Space, "Space"},
																			{Key::Escape, "Escape"},
																			{Key::Enter, "Enter"},
																			{Key::Tab, "Tab"},
																			{Key::Backspace, "Backspace"},
																			{Key::Insert, "Insert"},
																			{Key::Delete, "Delete"},
																			{Key::Right, "Right"},
																			{Key::Left, "Left"},
																			{Key::Down, "Down"},
																			{Key::Up, "Up"},
																			{Key::PageUp, "PageUp"},
																			{Key::PageDown, "PageDown"},
																			{Key::Home, "Home"},
																			{Key::End, "End"},
																			{Key::CapsLock, "CapsLock"},
																			{Key::ScrollLock, "ScrollLock"},
																			{Key::NumLock, "NumLock"},
																			{Key::PrintScreen, "PrintScreen"},
																			{Key::Pause, "Pause"},
																			{Key::F1, "F1"},
																			{Key::F2, "F2"},
																			{Key::F3, "F3"},
																			{Key::F4, "F4"},
																			{Key::F5, "F5"},
																			{Key::F6, "F6"},
																			{Key::F7, "F7"},
																			{Key::F8, "F8"},
																			{Key::F9, "F9"},
																			{Key::F10, "F10"},
																			{Key::F11, "F11"},
																			{Key::F12, "F12"},
																			{Key::LeftShift, "LeftShift"},
																			{Key::LeftControl, "LeftControl"},
																			{Key::LeftAlt, "LeftAlt"},
																			{Key::LeftSuper, "LeftSuper"},
																			{Key::RightShift, "RightShift"},
																			{Key::RightControl, "RightControl"},
																			{Key::RightAlt, "RightAlt"},
																			{Key::RightSuper, "RightSuper"},
																			{Key::Kb_Menu, "Kb_Menu"},
																			{Key::Kp0, "Kp0"},
																			{Key::Kp1, "Kp1"},
																			{Key::Kp2, "Kp2"},
																			{Key::Kp3, "Kp3"},
																			{Key::Kp4, "Kp4"},
																			{Key::Kp5, "Kp5"},
																			{Key::Kp6, "Kp6"},
																			{Key::Kp7, "Kp7"},
																			{Key::Kp8, "Kp8"},
																			{Key::Kp9, "Kp9"},
																			{Key::KpDecimal, "KpDecimal"},
																			{Key::KpDivide, "KpDivide"},
																			{Key::KpMultiply, "KpMultiply"},
																			{Key::KpSubtract, "KpSubtract"},
																			{Key::KpAdd, "KpAdd"},
																			{Key::KpEnter, "KpEnter"},
																			{Key::KpEqual, "KpEqual"},
																			{Key::Back, "Back"},
																			{Key::Menu, "Menu"},
																			{Key::VolumeUp, "VolumeUp"},
																			{Key::VolumeDown, "VolumeDown"},
																			{Key::Last, "Last"},
																	})

} // namespace tiba::input
